<?php
// Prevent reflex loading of webpages in system dirs, or of incorrect fileypes.. 
 $cpagename=$_SERVER['SCRIPT_NAME'];
 $apermittedexts=array('htm','html','php','asp','jsp');
 $cpagepath = pathinfo(str_replace('\\','/',$cpagename));
 if ($cpagepath['filename']=='sitemap') return ;
 // $cpagedir=substr($cpagepath['dirname'],strrpos($cpagepath['dirname'],'/')+1);
 if (strpos($cpagepath['dirname'],'/codebase/')!==false) return;
 if (substr($cpagepath['dirname'],-8)=='codebase') return;
 if (in_array($cpagepath['extension'],$apermittedexts)!=true)  return ; 

require_once 'core.php';

// Main content loader. Reads page and frame files into buffers, processes content and outputs to browser. 

// Set the working environment parameters....

if(isset($_GET[editkey]) || gets('authenticated')=='1' ):
// set admin mode if '?admin' is added to URL, or session indicates a logged-in admin.  
// Note that admin functions are loaded after page, so that all forms are in place. 
// Authenticated takes '1' or '0' instead of t/f for form compatibility. 
 ipcheck();
 setg('ok2admin',true);
//echo "ok2admin=true;\n";
else:
 setg('ok2admin',false);
// echo "ok2admin=false;\n";
endif;
setg('editing_disallowed',false);
if (isset($_GET['noadmin'])) setg('ok2admin',false) ;

// end of environment setup. 

// get content of page requested into a buffer: 
if (substr(pagefile,0,5)=='frame' && substr(pagefile,-9)=='frame.php') {
 // but not if the frame is being tested directly. 
 $callingpage = "<div style='margin:5px;width:100%;height:400px;border:1px solid black;background:teal;color:white;'><p style='text-align:center;margin-top:180px;'>Page content will appear here</p></div>"; 
} else {
 if (getg('ok2admin')){
  // without executing php.. 
  $fh = fopen($_SERVER['SCRIPT_FILENAME'], 'rb') or die("Error: can't open page file" );
  $callingpage=stream_get_contents($fh);
  fclose($fh);
 }else{
  // with execution of php..     
  ob_start();
  include($_SERVER['SCRIPT_FILENAME']);
  $callingpage = ob_get_contents();
  ob_end_clean();
  chdir(dirname($_SERVER['SCRIPT_FILENAME']));
  // If this is a temporary page, delete the file after reading its contents.. 
  if (substr($_SERVER['SCRIPT_FILENAME'],-13)=='.~preview.htm') unlink ($_SERVER['SCRIPT_FILENAME']);
 }
}

/*
Harvesting protection is now in page save routine, to reduce overhead.
$rxemail='([\w|\.|\-|\_]+?)@([\w|\.|\-\_]+?)';
if (harvesting_protection>0 && getg('ok2admin')==false) {
 $harvestct=0;
   $callingpage = preg_replace_callback("/$rxemail/siU",
   'munge_email', $callingpage,50,$harvestct);
 if (harvesting_protection>1){
   if ($harvestct>0) $callingpage="<h1 style='color:red'>Publication blocked.</h1><br><h3>This page contains email addresses which are vulnerable to robotic harvesting. </h3><br>Web publication has been inhibited to protect these addresses from being collected by junkmail operators. Please edit the page to remove or protect the vulnerable items." ;
   setg('editing_disallowed',true);
 }
}
*/
   
$ahead=tagdata($callingpage,'head', false);
$abody=tagdata($callingpage,'body', true);
$atitle=tagdata($ahead[2],'title', false);
$ametas=@getmetas($ahead[2]);

setg('hf_editlevel',site_editlevel);
setg('hf_editors',site_editors);

if (isset($ametas['hf_editlevel']['content'])) {
 setg('hf_editlevel', $ametas['hf_editlevel']['content']);
}
if (isset($ametas['hf_editors']['content'])) {
 setg('hf_editors', $ametas['hf_editors']['content']);
}
if (isset($ametas['hf_pagetype']['content'])) {
 setg('hf_pagetype', $ametas['hf_pagetype']['content']);
}

/* Determine menu file placement for this page, if meta tag present */
$sitemenu="";
if (isset($ametas['hf_menu']['content'])) $sitemenu=$ametas['hf_menu']['content'] ;
if (get('menu')) $sitemenu=get('menu');
setg('sitemenu',$sitemenu);

/* Establish frame file, if not default.. 
  framebase is path to frames rel to site webroot, with / 
  $framename is plain framedir name sent to parser
  -in increasing order of precedence: 
  default_frame is value from siteini.php
  $sframe is override from user session var
  $pframe is override from URL string ?frame=

*/

$framename=default_frame;
$sframe=gets('user_frame');
$pframe=@$ametas['hf_frame']['content'];
if (get('frame')) $pframe=get('frame');
if ($pframe=='default'){
  $sframe='';
  $pframe='';
  sets('user_frame','');
}
if ($sframe){
   // prevent directory traversals.. 
   if (substr($sframe,0,1)=='/' || substr($sframe,0,1)=='\\') $sframe=substr($sframe,1,255);
   if (strpos($sframe,'..')===false) {
        $framename=$sframe;   
   }
}
if ($pframe){
   if (substr($pframe,0,1)=='/' || substr($pframe,0,1)=='\\') $pframe=substr($pframe,1,255);
   if (strpos($pframe,'..')===false) {
        // if (strtolower(@$ametas['hf_pagetype']['content'])!='frontpage') $framename=$pframe;   
        $framename=$pframe;
        if (get('frame')) sets('user_frame',$pframe);
   }
}
if ($framename=='frame'){
 $framename = default_frame ;
}
$framefile = framebase . $framename . '/frame.php'; 
if (!file_exists($framefile)) $framefile=gets('fsroot') . $framefile;
// echo frame .">". $framename.">".$framefile;
define ('framedir', siteroot . framebase . $framename . '/',1);
define ('frame', $framename,1);

// Get content of frame page... 
ob_start();
include($framefile);
$thisframe = ob_get_contents();
ob_end_clean();
chdir(dirname($_SERVER['SCRIPT_FILENAME']));

// Show top message for missing frame:  
if (strlen($thisframe)<2):
 $thisframe="<body><b style='background:yellow;width:100%;'>Frame file $framename as ($framefile) not found, or body section missing. Displaying content body only.</b><br><!--CONTENT--></body>";
 sets('user_frame','');
endif;

// Separate out head and body sections of frame requested: 
$afhead=tagdata($thisframe,'head', false);
$afbody=tagdata($thisframe,'body', true);
$aftitle=tagdata($afhead[2],'title', false);
$afmetas=@getmetas($afhead[2]);

// Base returned headsection on frame head..
$thishead=$afhead[2];

/* Title and description handling: 
   If page header has no title, or title matches frame title, 
   then use first header as title, use first para as description, or next header if no paras. */

$page_id="undefined";

if (strlen($atitle[2])<2 || $atitle[2]==$aftitle[2] ) {
  $eols=array("\r","\n"); 
  // Title nonexistent or matching, generate title AND description. 
  $pfirstheading= tagdata($abody[2],'h[\d]', false);
  // Strip any tags inside heading... 
  $pfirstheading= strip_tags($pfirstheading[2]);
  $pfirstheading=str_replace($eols,'',$pfirstheading); 
  // unlikely to be encountered, but possibly strip symbols from heading if found..
  // $pfirstheading=preg_replace("/[^a-zA-Z0-9\s-_!.]/", "", $pfirstheading);
  $pdescription= tagdata($abody[2],'p', false);
  if ($pdescription[2]=='') {
    $pdescription= tagdata($abody[2],'div', false);
  }  
  if ($pdescription[2]=='') {
    $pdescription= tagdata($abody[2],'h[23456]', false);
  }  
    $pdescription[2]=strip_tags($pdescription[2]);
    $pdescription=str_replace($eols,'',$pdescription); 
    // $pdescription[2]=preg_replace("/[^a-zA-Z0-9\s-_!.]/", "", $pdescription[2]);
  $thisdesc=hf_truncate($pdescription[2],200);
  $thistitle= "<title>" . $aftitle[2] . " : " . $pfirstheading . "</title>";
  $short_title=$pfirstheading;
} else {  
  // Title and description present, use them. 
  $thistitle= "<title>" . $aftitle[2] . " :: " . $atitle[2] . "</title>";
  $thisdesc=@$ametas['description']['content'];
  $short_title=$atitle[2];
}

$fdesctag=@$afmetas['description']['content'];
$fkeywordtag=@$afmetas['keywords']['content'];
$thiskeywordtag=@$ametas['keywords']['content'];

// Set document type. Note that the doctype constant also changes the behaviour of the editor. 
// Presently, Hyperframe requires a site to have one consistent doctype. 
// Any doctype tags in pages or in the frame are ignored. 

$pdoctype=@$ametas['hf_doctype']['content'];
$thisdoctype=@$afmetas['hf_doctype']['content'];
if (stripos($pdoctype,"html")!==false){
   $thisdoctype=$pdoctype;
}
setg("doctype",$thisdoctype);

/* Determine sections to conceal in special pages */

$pinvisible=@$ametas['hf_hide']['content'];
$finvisible=@$afmetas['hf_hide']['content'];
if ($pinvisible && strncasecmp($finvisible,"none",4)!=0){
   $finvisible=$pinvisible;
}
if (get('hide')) $finvisible=get('hide');
if ($finvisible=='all') $finvisible="banner,top,left,right,bottom";
$ainvisible=explode(",",$finvisible,10);
$invis_css="";
foreach ($ainvisible as $invisible_element){
  $invisible_element=trim($invisible_element);
  if ($invisible_element !=""){
     if (substr($invisible_element,0,3)!="hf_") $invisible_element= "hf_" . $invisible_element;
     $invis_css .= "#$invisible_element {display:none;}";
  }
}

/*  Transfer informational metas from page headsection */
$htrans=array();
$frametitle=$aftitle[0];
$htrans[$frametitle]=$thistitle;
$htrans[$fdesctag]=$thisdesc;
$htrans[$fkeywordtag]=$thiskeywordtag;
$thishead=areplace($thishead,$htrans);

hf_history_add($short_title,siteroot.pagefile);

/*   Begin HTML send to browser..  */

echo setdoctype($thisdoctype) . "\n";
echo "<html><head>\n";

/* Insert standard js and css links (v4 change, keeps frame tidier) */

echo  '<link rel=stylesheet href="' .codedir. 'system.css' .jsindex. '" type="text/css">' . "\n";
echo  '<link rel=stylesheet href="' .framedir. 'frame.css' .jsindex.  '" type="text/css">' . "\n";
echo  '<script language="javascript" src="' .codedir. 'system.js' .jsindex. '"></script>' . "\n";
echo  '<script language="javascript" src="' .framedir. 'frame.js' .jsindex. '"></script>' . "\n";

/* Supply rest of head from frame.. */
echo $thishead ;

/* Set up js/css environment for browser  */
echo js_syspaths;
echo "<script>\n";
echo "var doctype='" . $thisdoctype . "';\n";
echo "var authenticated='".gets('authenticated')."';\n";
echo "var framefile='$framefile';";
echo "</script>\n";
if (strlen($invis_css)>0) { 
  echo "<style>$invis_css</style>" ;
}
echo "</head> \n";

// echo '<textarea rows=10 cols=120>'; var_dump($sitemenu); echo '</textarea>';


if (gets('ok2admin')<1) {
  // Caption images if NOT in edit mode.. 
  $abody[2]=hf_captioner($abody[2]);
}

// Remove 'shebang' if present as it does not need to be sent to browser.. 
   $abody[2]=remove_shebang($abody[2]);

if (gets('ok2admin')) {
  // If we are in admin mode, load the editing interface... 

  // Convert script tags to placeholders..
  $phptags=array('<?php','?>','<script','</script');
  $edittags=array('<textarea class="hf_script" title="Inline php script. Double-click to edit" readonly="readonly"><?php','?></textarea>','<textarea class="hf_script" title="Inline js script. Double-click to edit." readonly="readonly"><script','</script></textarea');
  $abody[2]=str_ireplace($phptags,$edittags,$abody[2],$script_count); 
  // Decide if user has rights to edit page.. 
  if (gets('authenticated')){
  // hf_h1_msg content is used as a flag to javascript to control editing options. 
    $specificeditor=false;
    if (strlen(getg('hf_editors'))>0){
      $ahf_editors=explode(',',getg('hf_editors'));
      foreach ($ahf_editors as $thisguy) {
        if (gets('usr')==trim($thisguy)){
          $specificeditor=true;
        }
      }
      // If editor ID not found and NO edit level set, bar all except admins.     
      if (getg('hf_editlevel')<1) setg('hf_editlevel',5);
      unset($ahf_editors);
    }  
    if (!$specificeditor){
     if (gets('user_privelege')< getg('hf_editlevel') ){
       setg('editing_disallowed',true);
       $abody[2]="<h1 id='hf_h1_msg_edit_lock'>-:Editing Disallowed:-</h1><b>You do not have sufficient priveleges to edit this page.</b>.<br><br>Privelege level " . getg('hf_editlevel') . " or page ownership is required.<br><br>You can view the rendered page <a href='?noadmin'> here</a>.";
     }
    }
  }
  if ($script_count>0){
   if (gets('user_privelege')< inline_scripts){
     if (gets('authenticated')){
       if (!$specificeditor){
         setg('editing_disallowed',true);
         $abody[2]="<h1 id='hf_h1_msg_edit_lock'>-:Editing Disallowed:-</h1><b>You do not have sufficient priveleges to edit pages containing scripts</b>.<br><br>You can view the rendered page <a href='?noadmin'> here</a>.";
       }
     }else{
       setg('editing_disallowed',true);
       $abody[2]="<h1 id='hf_h1_msg_edit_lock'>-:Login Required:-</h1>You need to authenticate yourself in order to see the source code of pages containing scripts. ";
     }
   }
  }

  //convert block tags if in edit mode:
  if (gets('ok2admin')) $abody[2]=brbr2p($abody[2]);
   // Build inline editor setup section: 
   $epreamble = '<script language="javascript" src="' . codedir . 'ck/ckeditor.js' . jsindex . '"></script>' . "\n";
   $epreamble .= '<div id="editable" contenteditable="false">';
   $epostfix = '</div closetag="editable">' . "\n";
  // Add to main page:
   //if (!editing_disallowed){
     // Not essential, but stops editor being loaded if  insufficient rights.. 
     $abody[2]= $epreamble . $abody[2] . $epostfix;
   //}
} 

$pagebody="<body>";
if (strlen($abody[1])>0) {$pagebody=$abody[1];}

// Send only page body if no frame or admin controls required, e.g on sitemap: 
if (stripos($finvisible,"frame")!==false){
   echo $pagebody . $abody[2] . "</body></html>"; 
   exit; //return true;
}
if (stripos(get('style'),"print")!==false){
   echo $pagebody . $abody[2] . "<script>window.print()</script></body></html>"; 
   exit; // return true;
}

// include admin bar if in admin mode: 
if (gets('ok2admin')) {
 $pagebody .=  '<div class="admindiv"><span id="hyperbar"></span><span id="hypermsg"></span></div>';
}

// Insert main page into frame body, and send to browser: 
echo $pagebody . str_replace("<!--CONTENT-->", $abody[2], $afbody[2]);

// Include admin functions after main page has been sent:
 if (gets('ok2admin')) {
   include('ajax.php');
   include('admin.php');
 }

echo '</body></html>' ;

exit;
//return true;
//}


function setdoctype($thisdoctype){
  switch ($thisdoctype) {
    case "HTML5":
        return '<!DOCTYPE html>';
        break;
    case "HTML4":
        return '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">';
        break;
    case "HTML4T":
        return '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">'; 
        break;
    case "HTML4F":
        return '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Frameset//EN" "http://www.w3.org/TR/html4/frameset.dtd">';
        break;
    case "XHTML":
        return '<!DOCTYPE html><!-- Warning: XHTML is not supported -->';
        break;
    case "XHTMLT":
        return '<!DOCTYPE html><!-- Warning: XHTML is not supported -->';
        break;
    case "XHTMLF":
        return '<!DOCTYPE html><!-- Warning: XHTML is not supported -->';
        break;
    default:
        return '<!DOCTYPE html>';
  }
}  

function xxxplugin($name){
  // no longer used
  $pluginphp = siteroot . path(pluginbase) . $name . '/' . 'plugin.php' ;
  $fspluginphp = fsroot . path(pluginbase) . $name . '/' . 'plugin.php' ;
  $fspluginjs = fsroot . path(pluginbase) . $name . '/' . 'plugin.js' ;
  $pluginjs = siteroot . path(pluginbase) . $name . '/' . 'plugin.js' ;
  $pfound=false;
  if (file_exists($fspluginjs)){
    $pfound=true;
    echo "<script type='text/javascript' src='$pluginjs'></script>";
  }
  if (file_exists($fspluginphp)){
    $pfound=true;
    return $fspluginphp;     
  }
  if ($pfound==false){
    if (debug||get('debug')) echo "<p style='color:red;'>Warning: Plugin <i>$name</i> failed to load.<p>";
  }
  return "" ;
}

function getUrlContents($url, $maximumRedirections = null, $currentRedirection = 0) {
    $result = false;
    $contents = @file_get_contents($url);
    // Check if we need to go somewhere else
    if (isset($contents) && is_string($contents))
    {
        preg_match_all('/<[\s]*meta[\s]*http-equiv="?REFRESH"?' . '[\s]*content="?[0-9]*;[\s]*URL[\s]*=[\s]*([^>"]*)"?' . '[\s]*[\/]?[\s]*>/si', $contents, $match);
        if (isset($match) && is_array($match) && count($match) == 2 && count($match[1]) == 1)
        {
            if (!isset($maximumRedirections) || $currentRedirection < $maximumRedirections)
            {
                return getUrlContents($match[1][0], $maximumRedirections, ++$currentRedirection);
            }
            $result = false;
        }
        else
        {
            $result = $contents;
        }
    }
    return $contents;
}

function areplace ($text, $replace) {
    $keys = array_keys($replace);
    $length = array_combine($keys, array_map('strlen', $keys));
    arsort($length);
   
    $array[] = $text;
    $count = 1;
    reset($length);
    while ($key = key($length)) {
        if (strpos($text, $key) !== false) {
            for ($i = 0; $i < $count; $i += 2) {
                if (($pos = strpos($array[$i], $key)) === false) continue;
                array_splice($array, $i, 1, array(substr($array[$i], 0, $pos), $replace[$key], substr($array[$i], $pos + strlen($key))));
                $count += 2;
            }
        }
        next($length);
    }
    return implode($array);
}

function hf_captioner($data="", $action='unspecified'){
//  $data = preg_replace_callback('~(<img.*alt=[\'"])(.*)([\'"].*(style=[\'"].*[\'"]).*>)~siU',
    $data = preg_replace_callback('~(<img.*src\s*=.*>)~siU',
    'cb_img_caption', $data, 1024);
    return $data;
}
function cb_img_caption($matches){
    $data=$matches[0];
    $src=hf_img_attr($data,'src');
    // If bad image or no alt text, no need to process caption..    
    if ($src=='') { return $data;}
    $alt=hf_img_attr($data,'alt');
    if ($alt=='') { return $data;}
    $title=hf_img_attr($data,'title');
    $style=hf_img_attr($data,'style');
    $class=hf_img_attr($data,'class');
    $rtn=$data;
    $spanwidth='';
    $sclass=' '.$class.' ';
    if (stristr($sclass," caption ")!==false){
    $class=str_ireplace("caption","",$class);
    $data=str_replace($alt, "",$data); // Do we want a caption AND an alt? Not sure. JAWS users might have advice.. 
    $rtn='<span class="'.$class.'" ><span style="display:table-row;"><span style="display:table-cell;">'.$data.'</span></span>';
    $rtn.='<span style="display:table-row;"><span class="caption-text">'.$alt.'</span></span></span>';
    }
    if (stristr($sclass," caption-top ")!==false){
    $class=str_ireplace("caption","",$class);
    $data=str_replace($alt, "",$data); 
    $rtn='<span class="'.$class.'" ><span style="display:table-row;"><span class="caption-text">'.$alt.'</span></span>';
    $rtn.='<span style="display:table-row;"><span style="display:table-cell;">'.$data.'</span></span></span>';
    }
    return $rtn;
}

function hf_img_attr($data,$attr='src'){
    // bugfix[4.1]: did not handle quotes correctly, now uses parameter for second quote so it must be same type as first
    //    $pmerr=preg_match('~'.$attr.'=\s*[\'"](.*)[\'"]~siU',$data,$pmout); 
    // 4.2- Modded to allow src without quotes -needs testing more thoroughly
    $pmerr=preg_match('~'.$attr.'=\s*([\'"\s])(.*)\1~siU',$data,$pmout); 

    if ($pmerr<1) return "";
    $rtn=$pmout[2];
    return $rtn;
}

function hf_css_attr($data,$attr=''){
     $data="'".$data."'";
    $pmerr=preg_match('~[;\'"]'.$attr.':(.*)[;\'"]~siU',$data,$pmout); 
    if ($pmerr<1) return "";
    $rtn=$pmout[1];
    return $rtn;
}

function hf_history_add($thistitle,$thispage){
  // gets last ten or so pages visited and lists them in a sidebar
  // Optionally don't add index page.. 
  // $apagefile=pathinfo($thispage);
  // if ($apagefile['filename'] == 'index') return;
  $ahistory=gets('history');
  if (is_array($ahistory)){
    $ahistory=array($thistitle=>$thispage)+$ahistory;
  }else{
    $ahistory=array($thistitle=>$thispage);  
  }
  if (count($ahistory)>9){
    $x=array_pop($ahistory);
  }
  sets('history',$ahistory);
}


function hf_history(){
  // gets last ten or so pages visited and lists them in a sidebar
  $out="";
  $ahistory=gets('history');
  foreach ($ahistory as $thistitle=>$thispage){
   $out.= "<a class=history_link href=$thispage >$thistitle</a>";
  }
  echo $out;
}

?>
