
CKEDITOR.editorConfig = function( config ) {
	// Define changes to default configuration here. For example:
	// config.language = 'en-gb';
	// config.uiColor = '#AADC6E';

// Browser settings are now in ckinline.js to avoid update probs.
   config.filebrowserBrowseUrl = '';
   config.filebrowserImageBrowseUrl = '';
   config.filebrowserFlashBrowseUrl = '';
   config.filebrowserUploadUrl = '';
   config.filebrowserImageUploadUrl = '';
   config.filebrowserFlashUploadUrl = '';
// By default, Hyperframe's version of CKEditor allows any valid HTML
// regardless of declared HTML version, although it removes broken or mismatched tags. 
// Place // before the allowedContent line to use a much stricter set of filtering rules (basically valid HTML5 only) 

// Test of php readonly:
// config.protectedSource.push( /<\?[\s\S]*?\?>/g );

config.allowedContent=true;
config.dataIndentationChars = '  ';
// config.toolbarCanCollapse = true;
config.toolbar = 'Hyperframe';

config.toolbar_Hyperframe =
[
	{ name: 'forms', items : [ 'Form', 'Checkbox', 'Radio', 'TextField', 'Textarea', 'Select', 'Button', 'ImageButton', 'HiddenField' ] },
	{ name: 'paragraph', items : [ 'NumberedList','BulletedList','-','Outdent','Indent','-','Blockquote','CreateDiv',
	'-','JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock' ] },
	{ name: 'insert', items : [ 'Flash','Table','SpecialChar','Iframe' ] },
	{ name: 'separators', items : [ 'HorizontalRule','hBreak' ] },
	{ name: 'separators', items : [ 'hSrcEdit' ] },
    { name: 'tools', items: ['ShowBlocks']},
'/',
	{ name: 'snddocument', items : [ 'hSave' , 'hPreviewPage'] },
	{ name: 'editing', items : ['Undo','Redo','Find','Replace','-','SelectAll' ] },
	{ name: 'styles', items : [ 'Format','FontSize' , 'TextColor','BGColor' ] },
	{ name: 'basicstyles', items : [ 'Bold','Italic','Underline','Strike','Subscript','Superscript','-','RemoveFormat'] },
	{ name: 'images', items : [ 'Image', 'hQuickImage' ] },
	{ name: 'links', items : [ 'Link','Unlink','Anchor'] },
];


config.toolbar_Full =
[
	{ name: 'snddocument', items : [ 'Source','-','Save','NewPage','DocProps','Preview','Print','-','Templates' ] },
	{ name: 'clipboard', items : [ 'Undo','Redo' ] },
	{ name: 'editing', items : [ 'Find','Replace','-','SelectAll','-','SpellChecker', 'Scayt' ] },
	{ name: 'forms', items : [ 'Form', 'Checkbox', 'Radio', 'TextField', 'Textarea', 'Select', 'Button', 'ImageButton', 
        'HiddenField' ] },
	'/',
	{ name: 'basicstyles', items : [ 'Bold','Italic','Underline','Strike','Subscript','Superscript','-','RemoveFormat' ] },
	{ name: 'paragraph', items : [ 'NumberedList','BulletedList','-','Outdent','Indent','-','Blockquote','CreateDiv',
	'-','JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock','-','BidiLtr','BidiRtl' ] },
	{ name: 'links', items : [ 'Link','Unlink','Anchor' ] },
	{ name: 'insert', items : [ 'Image','Flash','Table','HorizontalRule','Smiley','SpecialChar','PageBreak','Iframe' ] },
	'/',
	{ name: 'styles', items : [ 'Styles','Format','FontSize' ] },
	{ name: 'colors', items : [ 'TextColor','BGColor' ] },
	{ name: 'tools', items : [ 'Maximize', 'ShowBlocks' ] }
];

 
config.toolbar_Basic =
[
	['Bold', 'Italic', '-', 'NumberedList', 'BulletedList', '-', 'Link', 'Unlink','-','About']
];


};
