<?php
require_once 'core.php';
include_once 'scantree.php';
if (gets('authenticated')<1) {echo "<h2 style='color:red'>Access denied: Not logged in.</h2>"; exit; }
?><!doctype html><html><body><?php

if (get('mode')!=''){
  echo'<div id="q_preview1" style="background:#4488aa;color:white;">';
  $ilocation= 'img';
  $hostpage=get('hostpage');
  $hostpagename=stripext(basename($hostpage));
  $hostpagepath=pathname($hostpage,1);
  if (strlen($hostpagepath)>0) $ilocation=$hostpagepath . 'img';
  $ilocation=path($ilocation);
  // echo $hostpagepath . '<br>';
  if (get('mode')=='this_page') hf_imglist($ilocation, 360, 120,0, $hostpagename);
  if (get('mode')=='full_list') hf_imglist($ilocation, 360, 120,0);
  echo '</div></body></html>';
  exit;  
}

$direxclusions = array( 'cgi-bin', '.', '..', 'codebase', 'archive' ,'menu','frame','material','undo','tmp','log','.thumb');
$ck_callback=get('CKEditorFuncNum');
$actiontype=get('type');
$uploaddir="img";
$flatfile=false;
$treemode="standard";
if (gets('user_privelege')<3) $flatfile=true;
$caption="" ;
$filetypes='';
$treelist=true;

$actiontype='images';
$caption="Quick image upload and linking";
$filetypes=array('jpg','gif','png');
$initdir="img";
$uploaddir="~";
// $uploaddir needs to reflect html filename
$treelist=false;
  
?>

<link rel=stylesheet href="system.css" type="text/css">
<link rel=stylesheet href="dialog.css" type="text/css">

<div class='admindiv'><img src="<?php echo codedir ?>/img/hf_logo.gif" style="vertical-align:middle;text-align:left;" id="hyperbar_logo" >
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Filesystem Browser : &nbsp;&nbsp;&nbsp; <?php echo $caption; ?>
</div>
<?php
echo "<script>var actiontype = '$actiontype'; var ck_callback = '$ck_callback' </script>";
echo js_syspaths;
  foreach($_REQUEST AS $ptkey => $ptvalue) {
   ${$ptkey} = rawurldecode($ptvalue);
//  echo "$ptkey:<input type='text' name='$ptkey' value='$ptvalue'>";
  }
?>  

<script>
var mode='single';
var hostpage = opener.pagefile;
</script>



<div class='hf_tab' >
<script>
function setiframetabs(thistab) {
 document.getElementById('hf_ift1').style.background='#444444';
 document.getElementById('hf_ift2').style.background='#444444';
 document.getElementById('hf_ift1').style.color='#aaaa88';
 document.getElementById('hf_ift2').style.color='#aaaa88';
 thistab.style.background='#4488aa';
 thistab.style.color='#ffffaa';
}
document.write('<a href="quick.php?hostpage=' + hostpage + '&mode=this_page"  id="hf_ift1" onClick=setiframetabs(this) title="Show only those image files uploaded specifically for this page" target="qi_preview">Uploaded for this page</a>');
document.write('<a href="quick.php?hostpage=' + hostpage + '&mode=full_list"  id="hf_ift2" onClick=setiframetabs(this) title="Show all image files in this directory level of the website" target="qi_preview">All in this site section</a>');
document.getElementById('hf_ift1').style.background='#4488aa';
document.getElementById('hf_ift1').style.color='#ffffaa';
</script></div>

<iframe name='qi_preview' width="100%" height="400" id='qi_preview' src="" >Preview Area</iframe> 

<?php

if (in_array($actiontype,array('filenew','images','quick_img'))):

 if (ini_get('file_uploads')!=false):
   $maxfilesize=ini_get('upload_max_filesize');
   ?>
   <form name="uploader" id="uploadform" action="handler.php" method="POST" target="qi_preview" enctype="multipart/form-data">
   <table class="hf_quickimg_upload"><tr class='qi_sectiontop'><td colspan=2> 
   <label for="qi_fileclick">Local file to Upload: (Max file size <?php echo $maxfilesize ?>B)</label><input type="file" name="files[]" id="qi_fileselector" onChange="UpdateFileField(this.value)">
   </td></tr><tr><td>
   <input type="text" size="40" id="qi_fileclick" value="Click to select a file on this computer"onClick="javascript:document.getElementById('qi_fileselector').click()" title="Select ONE file from your local computer's hard disk or USB memory, for upload. This must be a jpg, gif or png file type. Note that very large files such as unprocessed digicam output will take a while to upload. Reducing the size to a value suitable for webpage display before uploading will save on upload time.">
   
   </td><td><input type="checkbox" id="qi_overwrite" name="overwrite" title="Check this box if the file you are uploading REPLACES an existing picture, for example where you are uploading an improved version of the same image. If it is unchecked AND the same file already exists on the server, your upload -and the link to it in the document- will be given a new filename to avoid the naming conflict." ><small>&nbsp;<label for="qi_overwrite">Allow over-writes</label></small> 
   <input type="hidden" name="MAX_FILE_SIZE" value="10485760">
   <input type = "hidden" name="action" value="<?php echo base64_encode('quick_image');?>">
   <input type = "hidden" name="type" value="images">
   <input type = "hidden" name="destdir" value="auto">
   </td></tr><tr><td><small>Smart Size Limiting:</small> <select name="downsizing" title="Sets the maximum dimensions for the image, preserving the aspect ratio and without cropping. Images smaller than the stated size will be unaffected. Larger images will be reduced using high quality interpolation. This function is provided for convenience, but should not be regarded as a substitute for proper image preparation work!">
   <option value="">None</option>
   <option value="1280x1024">1280x1024</option>
   <option value="1024x768">1024x768</option>
   <option value="800x600" selected>800x600</option>
   <option value="640x480" >640x480</option>
   <option value="400x400">400x400</option>
   <option value="320x240">320x240</option>
   <option value="240x200">240x200</option>
   <option value="180x120">180x120</option>
   <option value="120x80">120x80</option>
   <option value="80x80">80x80</option>
   </select> 
   </td><td><input type="button" class="hf_button" name="upload" value="Start Upload" onClick="DoUpload()">
   </td></tr></table><table class="hf_quickimg_link">
   
   <tr class='qi_sectiontop'><td>Host Page</td><td>Link URL to File 
   </td></tr><tr><td><input type="text" name="hostpage" value="" readonly="readonly" size=20 title="The webpage your image will be displayed in. Determined by where this uploader tool was invoked from."></td><td><input type="text" size=40 name="webpathname"" value="" readonly="readonly" title="The name and location for your file on the webserver. In this utility, it is decided automatically by the uploader, or by clicking on an existing file. If you wish to determine this manually, you should use the general purpose uploader instead.">
   </td></tr><tr><td><label for="qi_linkfullsize"> Click image to view in popup:</label></td><td><input checked title="Check this box to make it such that clicking the image in the document will open a copy of the full size specified in a popup window. Useful where you wish to place a reduced-size copy in the document." type = "checkbox" id="qi_linkfullsize" name="linkfullsize" >
   </td></tr><tr><td>Alignment in document:</td><td> <select name="alignment" title="Choose the placing of the image, and whether the image is to be in its own space, or to allow the document text to flow around it." >
   <option value="plain" selected>Document Default</option>
   <option value="left" >Left, in own space</option>
   <option value="float-left" >Left, with text flowing around</option>
   <option value="center" >Centrally, in own space</option>
   <option value="right" >Right, in own space</option>
   <option value="float-right" >Right, with text flowing around</option>
   <option value="" >Unstyled (HTML default)</option>
   </select></td></tr><tr><td>
   </td></tr><tr><td>Caption: </td><td><input type="text" name="caption" value="" size=60 title="Give your image a description, where appropriate."></td></tr><tr><td>
   </td></tr><tr><td>Display Caption  :</td><td> <select name="caption_style" title="Choose whether to display the caption as a mouseover dialog which appears whilst the cursor is over the image, or to place the caption above or below the image in a span element. Note that when the above/below method is chosen you do not see the caption in edit mode, but only when you preview or publish the page. This is to make image repositioning simpler.">
   <option value="" selected>Alt tag only</option>
   <option value="caption-title" >As Mouseover</option>
   <option value="caption" >Below Image</option>
   <option value="caption-top" >Above Image</option>
   </select></td></tr><tr><td>
   </td></tr><tr><td>Place image link into webpage:</td><td><input type="button" class="hf_button" value="Insert Image" onClick="javascript:pasteImgURL()">
   .. <label for="qi_autoclose">and close this window</label><input checked title="Close this window on completion" type = "checkbox" id="qi_autoclose" name="autoclose" >
   </td></tr></table>
   <input type = "hidden" name="usr" value="<?php echo base64_encode(gets('usr'))?>">
   <input type = "hidden" name="pwd" value="<?php echo base64_encode(gets('pwd'))?>">
   <input type = "hidden" name="authenticated" value="<?php echo base64_encode(gets('authenticated'))?>">
   <hr width=100%>
  </form>
  <?php
 else:
  echo "This server does not allow browser file uploads. Sorry.";
 endif;
endif;
?>
<script>
  if (document.uploader.destdir.value = "auto"){
    if (opener.pagefile != 'undefined'){
      document.uploader.hostpage.value = opener.pagefile;
      //  alert (opener.fsroot+'|'+opener.siteroot+ '|' +opener.pagedir+ '|' +opener.pagefile);
    }
  } 
  function UpdateFileField(newval){
    var fa=document.getElementById('qi_fileselector').files;
    var fsnum=fa[0].size;
    var filext=fa[0].name.split('.').pop();
    filext=filext.toLowerCase();
    if ("|jpg|jpeg|png|gif|".indexOf(filext)<1){
      alert("This file does not appear to be an image of a type suitable for webpages.")
      document.getElementById('qi_fileclick').value=newval + " {Unsuitable file type}"
      return
    }
    var filesize=Math.round(fsnum/(1024*1024)*10)/10;
    if (filesize>0){
      document.getElementById('qi_fileclick').value=newval + " {"+ filesize + "MB}" 
    }else{
      document.getElementById('qi_fileclick').value=newval + " {"+ fa[0].size + " bytes}" 
    }
    if (fsnum > parseFloat('<?php echo ini_get('upload_max_filesize')?>')*1024*1024){ alert('This file may be too large for upload')}
  }
  function DoUpload(action){
    var fa=document.getElementById('qi_fileselector').files;
    var filelist=fa
    numfiles=fa.length;
    if (numfiles==0){
      alert("No files selected, nothing to do.");
      return false;
    }  
    if (numfiles > <?php echo ini_get('max_file_uploads') ;?>){
      alert("Too many files selected. None uploaded." );
      return false;
    }  
    if (<?php echo gets('user_privelege') ;?> > 5){
      alert("Sorry. Uploads are not permitted in demo mode." );
      return false;
    }  
   document.uploader.upload.value="Sending Data..";
   document.uploader.submit();
   return true;
  }

</script>
<script>
function imgPreview(){
  var imgurl = document.getElementById('fileselector').value;
  imgurl=imgurl.replace('\\','/');
   alert(imgurl);
  
  document.getElementById('qi_preview').src=imgurl;
}

function pasteImgURL(){
  var img_url=document.uploader.webpathname.value;
  if (img_url=="" || img_url=='undefined'){
    alert ("You must upload an image, or select an existing image from the list before inserting a link to it in your webpage.");
    return false;
  }
  var caption=document.uploader.caption.value;
  var caption_class=document.uploader.caption_style.value;
  var alignment=document.uploader.alignment.value;
  var clickaction="";
  if (document.uploader.linkfullsize.checked){clickaction=' onClick="hf_imgzoom_popup(this.src)" '}
  
  // Determine image placement..
  // display=block prevents untidy text line, float=l/r allows text wraparound, margin=auto centers.    
  var img_alt="";
  var img_title="";
  var img_class=alignment;
  if (caption_class!="" && caption_class!='caption-title'){img_class += ' ' + caption_class; }
  if (caption_class=="caption-title"){img_title = caption; 
  }else{
    img_alt=caption;
  }
  var img_tag="<img src='"+img_url+"' id='"+img_url+"' "+clickaction+" alt='"+img_alt+"' class='"+img_class+"' title='"+img_title+"' >";

  // alert(img_tag);
  var doctarget = opener.CKEDITOR.instances.editable;
  doctarget.insertHtml(img_tag);
  if (document.uploader.autoclose.checked==true){ window.close(); }
}

document.getElementById('qi_preview').src='quick.php?hostpage=' + hostpage + '&mode=this_page';

</script>

<?php 
?>
</body></html>
